'use strict';
var yeoman = require('yeoman-generator');
var chalk = require('chalk');
var yosay = require('yosay');
var templateParams = require('../templateParams.json');
var os = require('os');
var util = require('../util');

module.exports = yeoman.Base.extend({
  prompting: function () {
    var prompts = [{
      type: 'confirm',
      name: 'answer',
      message: 'Would you like to generate PROTO?',
      default: true
    }];

    return this.prompt(prompts).then(function (props) {
      // To access props later use this.props.someAnswer;
      this.props = props;
    }.bind(this));
  },
  writing: function () {
    if (this.props.answer == false)
      return;

    if (!process.env.THOR_ROOT || !process.env.TARGET_DIR) {
      console.log("Error: Environment failed: THOR_ROOT or TARGET_DIR can not found.");
      return;
    }

    var genscriptPath = process.env.THOR_ROOT + '/util/bin/';
    
    genscriptPath += (os.type() === 'Dawin') ?  'osx_genscript.sh' : 'genscript.sh';

    util.execCmd('bash ' + genscriptPath + " arm ./include");
  }
});
