'use strict';
var yeoman = require('yeoman-generator');
var chalk = require('chalk');
var yosay = require('yosay');
var templateParams = require('../templateParams.json');

module.exports = yeoman.Base.extend({
  constructor: function(){ 
    yeoman.Base.apply(this, arguments);

    this.argument('modname', { type: String, required: true });
  },
  prompting: function () {
    // Have Yeoman greet the user.

    var prompts = [{
      type: 'confirm',
      name: 'answer',
      message: 'Would you like to import ' + this.modname + ' module ?',
      default: true
    }];

    return this.prompt(prompts).then(function (props) {
      // To access props later use this.props.someAnswer;
      this.props = props;
    }.bind(this));
  },

  writing: function () {
    var params = templateParams.params;
    var mainParam = params.main;
    var defNameParam = params.defName;

    var importPath = 'src/OFK'+this.appname+'.c';
    var defnamePath = 'src/OFKDefIfName.h';

    if (this.props.answer == false)
      return;

    mainParam.OFK_USINGIF_DECLARE += "\nOFK_USINGIF_DECLARE_OFK_" + this.modname + "If(" + this.modname + ")";
    mainParam.OFK_USINGIF_LIST += "\n\tOFK_USINGIF(" + this.modname + ")";

    defNameParam.OFK_VARIF_DECLARE += "\n#define OFK_VARIF_OFK_" + this.modname + "If _ofk_" + this.appname + this.modname + "If_";

    var tplData = [];
    
    tplData.push([importPath, importPath, mainParam]);
    tplData.push([defnamePath, defnamePath, defNameParam]);

    tplData.forEach((e)=>{
      this.fs.copyTpl( e[0], e[1], e[2] );
    });

  }

});
